#ifndef STR8_H
#define STR8_H

#include "aliases.h"

#ifdef __cplusplus
BEGIN_C_LINKAGE
#endif // !__cplusplus

typedef struct str8 Str8;
struct str8 {
  u64 capacity;
  u64 size;
  u8 *buf;
};

Str8 wapp_str8_lit(char *str);
char wapp_str8_get(const Str8 *str, u64 index);
void wapp_str8_set(Str8 *str, u64 index, char c);

#ifdef __cplusplus
END_C_LINKAGE
#endif // !__cplusplus

#endif // !STR8_H
